//     Copyright 2011 Reuben D'Netto
//
//     This file is part of SMWebUI.
// 
//     SMWebUI is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     SMWebUI is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with SMWebUI.  If not, see <http://www.gnu.org/licenses/>.
// 


var RefreshRate = 1000; //(ms)


function UpdateStatus(setTimer){
	//disable/enable buttons
	setRepeatEnabled(eval(getValue("pl_repeat")));
	setShuffleEnabled(eval(getValue("pl_shuffle")));
	setIsMute(eval(getValue("mute")));

	var status = sendQuery("status");
	Status_Message.innerText = status;
	Play_lnk.className = (status == "Playing" ? "disabled" : "");
	Pause_lnk.className = (status == "Stopped" ? "disabled" : "");
	Mute_lnk.className = Pause_lnk.className;

	Rewind_lnk.className = Pause_lnk.className;
	Forward_lnk.className = Pause_lnk.className;

	//Clip info
	var clipInfo = eval(sendQuery("clipinfo")); //struct with the values shown below
	ClipInfo_filename.innerText = clipInfo.filename;
	ClipInfo_duration.innerText = ToTimeString(clipInfo.duration);
	ClipInfo_title.innerText = clipInfo.title;
	ClipInfo_artist.innerText = clipInfo.artist;
	ClipInfo_author.innerText = clipInfo.author;
	ClipInfo_album.innerText = clipInfo.album;
	ClipInfo_genre.innerText = clipInfo.genre;
	ClipInfo_date.innerText = clipInfo.date;
	ClipInfo_track.innerText = clipInfo.track;
	ClipInfo_copyright.innerText = clipInfo.copyright;
	ClipInfo_comment.innerText = clipInfo.comment;
	ClipInfo_software.innerText = clipInfo.software;
	Status_Song.innerText = (clipInfo.title == "") ? clipInfo.filename : (clipInfo.title + " - " + clipInfo.artist);

	//ClipInfo_position.innerText = clipInfo.position;
	Position_Slider.max = clipInfo.duration;
	Position_Slider.value = clipInfo.position;
	Status_Position.innerText = ToTimeString(clipInfo.position) + " / " + ToTimeString(clipInfo.duration);
	Volume_Slider.value = sendQuery("volume");

	if(showPlaylist) UpdatePlaylist();
	if(setTimer) setTimeout("UpdateStatus(true);", RefreshRate);
}

function UpdatePlaylist(){
	var playlist = eval(sendQuery("playlist")); //array of {name, path, length}
	var output = "<table style='width: 100%;'><tbody>\n";
	output += "\t<tr><th>Name</th><th>Length</th></tr>\n";
	
	for(var i = 0; i < playlist.length; i += 1){
		//do not call UpdateStatus() for remove, as the status will be stopped for a brief moment while the media loads
		
		var row = ("\t<tr><td><a href='#' title='$PATH' onclick='sendCommand(\"playItem=\" + $INDEX);'>$NAME</a></td><td>$LENGTH</td><td>\n"
			+ "\t\t<a class='$UpClass' href='#' onclick='MoveUp($INDEX, $N);'><img class='smallButtonImg' src='images/up.png' alt='Move Up' /></a>&nbsp;\n"
			+ "\t\t<a class='$DownClass' href='#' onclick='MoveDown($INDEX, $N);'><img class='smallButtonImg' src='images/down.png' alt='Move Down' /></a>&nbsp;\n"
			+ "\t\t<a href='#' onclick='sendCommand(\"remove=\" + $INDEX);'><img class='smallButtonImg' src='images/delete.png' alt='Delete' /></a>\n"
			+ "</td></tr>\n\n");
		row = row.replace(/\$NAME/g, playlist[i].name)
				 .replace(/\$PATH/g, playlist[i].path)
		 		 .replace(/\$LENGTH/g, (playlist[i].length == 0 ? "" : ToTimeString(playlist[i].length)))
				 .replace(/\$INDEX/g, i)
				 .replace(/\$N/g, playlist.length)
				 .replace(/\$UpClass/g, (i == 0 ? "disabled" : ""))
				 .replace(/\$DownClass/g, (i == (playlist.length - 1) ? "disabled" : ""));
		output += row;
	} //end for
	
	output += "</tbody></table>";	
	Playlist_Container.innerHTML = output;
}

function init(){
document.cookie = "";

	//automatically assign elements to variables matching their IDs
	var links = AutoAssign("a");
	AutoAssign("img");
	AutoAssign("p");
	AutoAssign("td")
	AutoAssign("input");

	//disable buttons/links for features that are not yet implemented
	for(var i = 0; i < links.length; i += 1){
		if(links[i].id.indexOf("_") == -1) continue;

		var func = links[i].id + "_onclick";
		if(eval("typeof " + func) != "function")
			links[i].className = "disabled";
	} //end for

	//initialize toggle buttons
	setShowPlaylist(getCookie("showPlaylist", false));
	setShowClipInfo(getCookie("showClipInfo", false));
	
	showOpenFile = false;

	if(! eval(sendQuery("legacyMode"))) Status_Warning.style.display = "none";

	UpdateStatus(true);
}
