//     Copyright 2011 Reuben D'Netto
//
//     This file is part of SMWebUI.
// 
//     SMWebUI is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     SMWebUI is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with SMWebUI.  If not, see <http://www.gnu.org/licenses/>.
// 


var repeatEnabled, shuffleEnabled, showPlaylist, showClipInfo, showOpenFile, isMute;

function setShowPlaylist(value){
	if(value) UpdatePlaylist();
	showPlaylist = value;
	setCookie("showPlaylist", value);
	Playlist_Container.style.display = (value ? "" : "none");
	ShowPlaylist_btn.style.borderStyle = (value ? "inset" : "outset");
}
function setShowClipInfo(value){
	showClipInfo = value;
	setCookie("showClipInfo", value);
	ClipInfo_Container.style.display = (value ? "" : "none");
	ShowClipInfo_btn.style.borderStyle = (value ? "inset" : "outset");
}
function setShowOpenFile(value){
	showOpenFile = value;
	OpenFile_Container.style.display = (value ? "" : "none");
	ShowOpenFile_btn.style.borderStyle = (value ? "inset" : "outset");
}
function setRepeatEnabled(value){
	repeatEnabled = value;
	Repeat_btn.style.borderStyle = (value ? "inset" : "outset");	
	sendAction("pl_repeat " + value);
}
function setShuffleEnabled(value){
	shuffleEnabled = value;
	Shuffle_btn.style.borderStyle = (value ? "inset" : "outset");	
	sendAction("pl_shuffle " + value);
}
function setIsMute(value){
	isMute = value;
	Mute_btn.style.borderStyle = (value ? "inset" : "outset");	
	Mute_img.src = (value ? "images/mute.png" : "images/volume.png");
	sendAction("mute " + value);	
}

function MoveUp(i, n){
	if(i == 0) return;
	sendCommand("moveUp=" + i); 
	UpdatePlaylist();
}
function MoveDown(i, n){
	if(i == (n-1)) return;
	sendCommand("moveDown=" + i); 
	UpdatePlaylist();
}

function OpenFile(cmd){
	//cmd is either 'open' or 'add'
	sendCommand(cmd + "=" + Path_Txt.value);
	Path_Txt.value = "";
	setShowOpenFile(false);
}
