//     Copyright 2011 Reuben D'Netto
//
//     This file is part of SMWebUI.
// 
//     SMWebUI is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     SMWebUI is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with SMWebUI.  If not, see <http://www.gnu.org/licenses/>.
// 


//Utility functions
function trim(str){
	var regex = new RegExp("^\\s*|\\s$", "gm");
	return str.replace(regex, "");
}

function ToTimeString(secs){
	var h = Math.floor(secs / 3600);
	var m = Math.floor((secs % 3600) / 60);
	var s = secs % 60;

	if(h > 0 && m < 10) m = "0" + m;
	if(s < 10) s = "0" + s;

	if(h > 0)
		return h + ":" + m + ":" + s;
	else
		return m + ":" + s;
}

function AutoAssign(element){
	var elements = document.getElementsByTagName(element);
	
	for(var i = 0; i < elements.length; i += 1){
		if(elements[i].id.indexOf("_") != -1)
			eval("var ID = document.getElementById(\"ID\");".replace("ID", elements[i].id));
	} //end for

	return elements;
}

function getCookie(_name, defaultValue){
	var cookies = document.cookie.split(";");
	
	for(var i = 0; i < cookies.length; i += 1){
		var n = trim(cookies[i].slice(0, cookies[i].indexOf("=")));
				
		if(_name == n)
			return eval(cookies[i].slice(cookies[i].indexOf("=") + 1));
	} //end for
	
	return defaultValue;
}
function setCookie(_name, _value){
	document.cookie = _name + "=" + _value;
}

//Protocol functions
function sendCommand(query){
	try{
		var request = new XMLHttpRequest();
		request.open("GET", "/smplayer?" + query, false);
		request.send();
	}catch(e){
		document.write("Error connecting to server: <br />" + e + "<br /><br /><a href='#' onclick='location.reload();'>Click here</a> to retry.");
		throw e;
	} //end try, catch
}
function sendQuery(query){
	try{
		var request = new XMLHttpRequest();
		request.open("GET", "/smplayer?" + query, false);
		request.send();
		return trim(request.responseText);
	}catch(e){
		document.write("Error connecting to server: <br />" + e + "<br /><br /><a href='#' onclick='location.reload();'>Click here</a> to retry.");
		throw e;
	} //end try, catch
}

function sendFunction(f){
	sendCommand("function=" + f);
}
function sendAction(action){
	sendCommand("action=" + action);
}
function getValue(_name){
	return sendQuery("get=" + _name);
}
